#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=ini\favicon.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
; #Description programme# ============================================================================================
; # Création # ===========:        27/10/2016
; # Auteur # =============:
; # Service # ============:
; # Description # ========:
; # Modification # =======:        Dernière modification le xx/xx/20xx
; # Nature modification # :
	  ; #xx/xx/20xx: ********************************************# ===================================================
	  ; #xx/xx/20xx: ********************************************# ===================================================
	  ; #xx/xx/20xx: ********************************************# ===================================================

#AutoIt3Wrapper_Run_AU3Check=n

; #Includes# =========================================================================================================
#include <GUIConstantsEx.au3>
#include <StaticConstants.au3>
#include <WindowsConstants.au3>
#include <File.au3>
#include <Array.au3>
#include <ArrayEx.au3>
#include <GuiTreeView.au3>
#include <MsgBoxConstants.au3>
#include <GuiStatusBar.au3>
#include <Timers.au3>
#include <StringSize.au3>
#include <Date.au3>
#include <StringSize.au3>
#include <GuiListView.au3>
#include <SQLite.au3>
#include <SQLite.dll.au3>
#include <Excel.au3>
#include <GuiComboBox.au3>
#include <GuiComboBoxEx.au3>
#include <GuiListBox.au3>
#include <EditConstants.au3>
#include<WinAPI.au3>
#include <WinNet.au3>
;#include <FileListToArrayEx.au3>
;#include <FileListToArrayXT.au3>

; #Options# ============================================================================================================
Opt("MustDeclareVars", 1)
Opt("GUIOnEventMode", 1)
Opt("MouseCoordMode", 2)

; #Variables# ==========================================================================================================
Global $Admin[5] = [@UserName]
Global $Author = ""
Global $hGUI, $hStatus, $aParts[4]=[200, 450, 700, 200], $Area[6], $WorkArea, $hGUI_2
Global $iTimer, $hIcons, $hIcons2, $WorkAera, $ControlSize, $Text, $Size
Global $CoefW, $CoefH, $Width = 800, $Height = 600
Global $wLabel=3, $iSize=12, $sFont="Courier New"
Global $DarkBlue, $White, $Green, $Red, $Orange, $Yellow, $Purple, $SilverGrey, $LightGrey
Global $hTitle, $hLine
Global $ConfigFile = @ScriptDir & "\ini\Config.ini"
Global $ConfigCell = @ScriptDir & "\ini\Cells.ini"
Global $ConfigMaterial = @ScriptDir & "\ini\Material.ini"
Global $ConfigMesure = @ScriptDir & "\ini\MesurePoint.ini"
Global $c_Line, $c_Cell, $c_Material, $c_Tool, $c_Search
Global $Label1, $Label2, $Label3, $Label4, $Label5, $Label6, $Label7, $Label8, $Label9, $Label10, $Label11, $Label12
Global $Label13, $Label14, $Label15, $Label16, $Label17, $Label18, $Label19, $Label20
Global $iDefault, $hListView, $hListView2, $iApplicant, $bValider, $aLine, $aCell, $sCell, $sLineCompose, $aLineCompose
Global $aSplit, $sSection, $aMaterial, $aTool, $sHelp, $aDefault, $iSearch, $bSearch, $bCancel
Global $iDefect, $iChange, $iIntervenant,$bValiderIntervention, $bExtractionExcel, $c_ToolInPlace, $aSerial2, $sSerial2, $ahlp
Global $iComment, $iValvePlace, $iValveIn, $iValveOut
Global $sDisplayName = 0, $oADsUser = 0, $oADSystemInfo, $sHTML, $oIE, $iDemandeur, $bStat, $iRvalSearch, $TxtNumberRecord
Global $IndexItemListView
; #SQL# ================================================================================================================
Global $sLocalSQLiteDll = @ScriptDir & "\_SQLIte\sqlite3.dll"
Global $SQLite = @ScriptDir & "\_SQLIte\ToolsManager.sqlite"
Global $Base_SQLite, $sQuery, $Table
; ======================================================================================================================

;_LogUser()
_InitSql()
_Ini()
_Main()

GUIRegisterMsg($WM_NOTIFY, "WM_NOTIFY")
;GUIRegisterMsg($WM_COMMAND, "WM_COMMAND")
GUIRegisterMsg($WM_SIZE, "WM_SIZE")
GUIRegisterMsg($WM_TIMER, "WM_TIMER")
$iTimer = _Timer_SetTimer($hGUI, 1000)

_ScreenAdaptation()
While GUIGetMsg()<>-3
WEnd

; #Programme# ==========================================================================================================

; #Func LogUser# =======================================================================================================
; Tracker
; ======================================================================================================================
Func _LogUser()
   _FileWriteLog(@ScriptDir & "\log\Debug.log", StringUpper(@UserName) & ";" & @ComputerName & ";" & @IPAddress1 & "; Start of application.")
EndFunc

; #Func _IniSql# =======================================================================================================
;Initialisation et contrôle base Sql
; ======================================================================================================================
Func _InitSql()
   _SQLite_Startup($sLocalSQLiteDll, False, 1)
   If @error Then
	  MsgBox(0, "Fichier manquant", "Le fichier SQLite3.dll est introuvable !")
	  Exit
   EndIf
   $Base_SQLite = _SQLite_Open($SQLite)
   If @error > 0 Then
	  MsgBox(16, "SQLite Erreur", "La base ne peut être chargée !")
	  Exit
   EndIf
   OnAutoItExitRegister("_Exit_SQLite")
EndFunc   ;==>_InitSql

; #Func _Exit_SQLite# ==================================================================================================
;ShutDown de la base Sql
; ======================================================================================================================
Func _Exit_SQLite()
   _SQLite_Close()
   _SQLite_Shutdown()
EndFunc   ;==>_Exit_SQLite

; #Func _Ini# ==========================================================================================================
;Définition des couleurs standards
;Niveau d'accès users
; ======================================================================================================================
Func _Ini()
   $DarkBlue=0x000080
   $White=0xFFFFFF
   $Green=0x008000
   $Red=0xFF0000
   $Orange=0xFFA500
   $Yellow=0xFFFF00
   $Purple=0xFD3F92
   $SilverGrey=0xC0C0C0
   $LightGrey=0xD3D3D3
EndFunc

; #Func _Main# =========================================================================================================
;Programme principal
; ======================================================================================================================
Func _Main()
; #Main GUI# ===========================================================================================================
   $hGUI = GUICreate("", $Width, $Height, -1, -1, $WS_POPUP)
   GUISetOnEvent($GUI_EVENT_CLOSE, "_Exit")

; #Label# ==============================================================================================================
   $hTitle = GUICtrlCreateLabel(IniRead($ConfigFile, "PARAMETERS", "Title", "DemoMode"), 1, 1, $Width, 30, BitOR($SS_CENTER, $SS_CENTERIMAGE))
   GUICtrlSetColor(-1, $White)
   GUICtrlSetBkColor(-1, $DarkBlue)

   $Label1 = GUICtrlCreateLabel("Ligne", 1, 1)
   $Label2 = GUICtrlCreateLabel("Station", 1, 1)
   ;$Label3 = GUICtrlCreateLabel("Outillage", 1, 1)
   $Label4 = GUICtrlCreateLabel("Recherche par matériel", 1, 1)
   $Label5 = GUICtrlCreateLabel("   ", 1, 1, 1, 30, BitOR($SS_CENTER, $SS_CENTERIMAGE))
   GUICtrlSetColor(-1, $White)
   GUICtrlSetBkColor(-1, $SilverGrey)


; #ComboBox# ===========================================================================================================
   $c_Line = GUICtrlCreateCombo("", 1, 1, 1, 1, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL))
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")
   $aLine = IniReadSection($ConfigFile, "LINE")
   If Not @error Then
	  For $i=1 To $aLine[0][0]
		 GUICtrlSetData($c_Line, $aLine[$i][0])
	  Next
   EndIf
   GUICtrlSetOnEvent($c_Line, "_FillCell")

   $c_Cell = GUICtrlCreateCombo("", 1, 1, 1, 1, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL))
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")
   GUICtrlSetOnEvent($c_Cell, "_MaterialChange")

   $c_Search = GUICtrlCreateCombo("", 1, 1, 1, 1, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL))
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")
   GUICtrlSetOnEvent($c_Search, "_LikeSearch")
   _Equipment()

; #ListView# ===========================================================================================================
   $hListView = GUICtrlCreateListView("ID|Date|Ligne|Station|Matériel|Matériel enlevé|Matériel en place|Emplacement station|Commentaire|Demandeur", 1, 1, 1, 1)
   ;_GUICtrlListView_SetExtendedListViewStyle($hListView, BitOR($LVS_EX_FULLROWSELECT, $LVS_EX_SUBITEMIMAGES))
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")
   _GUICtrlListView_HideColumn($hListView, 0)

; #InputBox# ===========================================================================================================

; #Button# =============================================================================================================
   $bExtractionExcel = GUICtrlCreateButton(" Extraction base de données dans Excel ", 1, 1)
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")

   $bStat = GUICtrlCreateButton(" Statistiques globales outillages ", 1, 1)
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")

; #StatusBar# ==========================================================================================================
   $hStatus = _GUICtrlStatusBar_Create($hGUI, -1, "", $SBARS_TOOLTIPS)
   _GUICtrlStatusBar_SetParts($hStatus, $aParts)
   DllCall("UxTheme.dll", "int", "SetWindowTheme", "hwnd", $hStatus, "wstr", 0, "wstr", 0)
   $hIcons = _WinAPI_LoadShell32Icon(265)
   _GUICtrlStatusBar_SetIcon($hStatus, 0, $hIcons)
   $hIcons2 = _WinAPI_LoadShell32Icon(160)
   _GUICtrlStatusBar_SetIcon($hStatus, 1, $hIcons2)
   _GUICtrlStatusBar_SetText($hStatus, @LogonDomain & "\" & StringUpper(@UserName) & " on " & @ComputerName, 1)
   _GUICtrlStatusBar_SetText($hStatus, "Powered By " & $Author, 2)
   GUISetState(@SW_SHOW, $hGUI)
EndFunc

; #Func _Equipment =====================================================================================================
;Fill ComboBox according save items into SQL
;=======================================================================================================================
Func _Equipment()
   GUICtrlSetData($c_Search, "")
   Local $_iRvSearch, $_aRSearch, $_iRSearch, $_iCSearch
   $_iRvSearch = _SQLite_GetTable2d(-1, "SELECT tbl_name FROM sqlite_master name;",  $_aRSearch, $_iRSearch, $_iCSearch)
   If $_iRvSearch = $SQLITE_OK Then
	  Local $_Range="0"
	  _ArrayDelete($_aRSearch, $_Range)
	  $_aRSearch = _ArrayUnique($_aRSearch)
	  For $a=2 To $_aRSearch[0]
		 GUICtrlSetData($c_Search, $_aRSearch[$a])
	  Next
   EndIf
EndFunc

; #Func _MaterialChange# ===============================================================================================
;
;=======================================================================================================================
Func _MaterialChange()

   GUISetState(@SW_DISABLE, $hGUI)
   $hGUI_2 = GUICreate(IniRead($ConfigFile, "PARAMETERS", "Title", "DemoMode"), $Width, $Height - 2, -1, -1, $WS_POPUP);, 650, 273)
   GUISetOnEvent($GUI_EVENT_CLOSE, "_CloseMaterialChange")
   GUISetBkColor(0xa3a3a3)

   Local $hTitle2 = GUICtrlCreateLabel("Fiche remplacement matériel", 1, 1, $Width - 2, 30, BitOR($SS_CENTER, $SS_CENTERIMAGE))
   GUICtrlSetColor(-1, $White)
   GUICtrlSetBkColor(-1, $DarkBlue)
   GUICtrlSetFont($hTitle2, 10, 400, 0, $sFont)

   GUICtrlCreateLabel("Outillage:", 5, 35, 200, 20)
   GUICtrlSetFont(-1, 11, 800, 0, $sFont)

   $c_Material = GUICtrlCreateCombo("", 5, 55, 250, 20, BitOR($CBS_DROPDOWNLIST, $WS_VSCROLL))
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")
   GUICtrlSetOnEvent($c_Material, "_FillRemoveTool")

   $aSplit = StringSplit(GUICtrlRead($c_Cell), " ")
   $sSection =  $sLineCompose & "_" & $aSplit[1]
   $aMaterial = IniReadSection($ConfigMaterial, $sSection)

   If Not @error Then
	  For $j = 1 To $aMaterial[0][0]
		 GUICtrlSetData($c_Material, $aMaterial[$j][0])
	  Next
   EndIf

   GUICtrlCreateLabel("Outillage retiré:", 5, 85, 200, 20)
   GUICtrlSetFont(-1, 11, 800, 0, $sFont)

   $c_Tool = GUICtrlCreateCombo("", 5, 105, 250, 20, BitOR($CBS_DROPDOWN, $CBS_AUTOHSCROLL, $CBS_DROPDOWNLIST))
   GUICtrlSetFont(-1, 10, 400, 0, $sFont)

   GUICtrlCreateLabel("Outillage mis en place:", 280, 85, 250, 20)
   GUICtrlSetFont(-1, 11, 800, 0, $sFont)

   $c_ToolInPlace = GUICtrlCreateCombo("", 280, 105, 250, 20, BitOR($CBS_DROPDOWN, $CBS_AUTOHSCROLL, $CBS_DROPDOWNLIST))
   GUICtrlSetFont(-1, 10, 400, 0, $sFont)
   GUICtrlSetOnEvent($c_Tool, "_ToolInPlace")

   $Label6=GUICtrlCreateLabel("Emplacement vanne:", 5, 135, 250, 20)
   GUICtrlSetFont(-1, 11, 800, 0, $sFont)
   GUICtrlSetState(-1, $GUI_HIDE)

   $iValvePlace = GUICtrlCreateInput("", 5, 155, 250, 25, BitOR($GUI_SS_DEFAULT_INPUT, $ES_NUMBER))
   GUICtrlSetFont(-1, 10, 400, 0, $sFont)
   GUICtrlSetState(-1, $GUI_HIDE)

   $Label7=GUICtrlCreateLabel("N° vanne retirée:", 280, 135, 250, 20)
   GUICtrlSetFont(-1, 11, 800, 0, $sFont)
   GUICtrlSetState(-1, $GUI_HIDE)

   $iValveOut = GUICtrlCreateInput("", 280, 155, 250, 25, BitOR($GUI_SS_DEFAULT_INPUT, $ES_NUMBER))
   GUICtrlSetFont(-1, 10, 400, 0, $sFont)
   GUICtrlSetState(-1, $GUI_HIDE)

   $Label8=GUICtrlCreateLabel("N° vanne mise en place:", 280, 185, 250, 20)
   GUICtrlSetFont(-1, 11, 800, 0, $sFont)
   GUICtrlSetState(-1, $GUI_HIDE)

   $iValveIn = GUICtrlCreateInput("", 280, 205, 250, 25, BitOR($GUI_SS_DEFAULT_INPUT, $ES_NUMBER))
   GUICtrlSetFont(-1, 10, 400, 0, $sFont)
   GUICtrlSetState(-1, $GUI_HIDE)

   GUICtrlCreateLabel("Demandeur:", 5, 285, 200, 20)
   GUICtrlSetFont(-1, 11, 800, 0, $sFont)

   $iDemandeur = GUICtrlCreateInput("", 5, 300, 250, 25, BitOR($ES_MULTILINE, $WS_BORDER))
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")

   GUICtrlCreateLabel("Commentaire(s):", 5, 330, 200, 20)
   GUICtrlSetFont(-1, 11, 800, 0, $sFont)

   $iComment = GUICtrlCreateInput("", 5, 350, 525, 100, BitOR($ES_MULTILINE, $WS_BORDER))
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")

   $hListView2 = GUICtrlCreateListView("", 5, 460, 525, 130, BitOR($LVS_REPORT, $LVS_SHOWSELALWAYS))
   _GUICtrlListView_InsertColumn($hListView2, 0, "Nature du défaut", 520)
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")

   $bValider = GUICtrlCreateButton("Valider", 565, 505, 200, 25)
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")
   GUICtrlSetOnEvent($bValider, "_Check")

   $bCancel = GUICtrlCreateButton("Annuler", 565, 535, 200, 25)
   GUICtrlSetFont(-1, 9, 400, -1, "Courier New")
   GUICtrlSetOnEvent($bCancel, "_CloseMaterialChange")

   GUISetState(@SW_SHOW)
EndFunc

Func _CheckSQL()
  Local $iRvSearch, $aRSearch, $iRSearch, $iCSearch
   $iRvSearch = _SQLite_GetTable2d(-1, "SELECT tbl_name FROM sqlite_master name;", $aRSearch, $iRSearch, $iCSearch)

   If $iRvSearch = $SQLITE_OK Then
	  Local $Range="0;1"
	  _ArrayDelete($aRSearch, $Range)
	  $aRSearch = _ArrayUnique($aRSearch)
	  _ArrayDisplay($aRSearch)
	  _ArraySearch($aRSearch, GUICtrlRead($c_Material))
	  If @error Then
		 _SQLite_Exec(-1, "CREATE TABLE " & Chr(34) & GUICtrlRead($c_Material) & Chr(34) &  " (ID INTEGER PRIMARY KEY NOT NULL, _Date DEFAULT (null), Line DEFAULT (null), Cell DEFAULT (null), ToolOut, ToolIn, ToolPlace DEFAULT (null), Comments DEFAULT (null), Applicant DEFAULT (null));");
		 MsgBox(64, "", GUICtrlRead($c_Material) & " créée avec succès!")
		 _Equipment()
	 Else
		 MsgBox(64, "", GUICtrlRead($c_Material) & " existe déjà!")
	  EndIf
  EndIf
EndFunc

; #Func _Check# ========================================================================================================
;Check if all controls are filled before save into SQL
;=======================================================================================================================
Func _Check()
   If GUICtrlRead($c_Line) = "" Then
	  MsgBox(48, "", "Veuillez saisir une ligne!", -1, $hGUI_2)

   ElseIf GUICtrlRead($c_Cell) = "" Then
	  MsgBox(48, "", "Veuillez saisir une station!", -1, $hGUI_2)

   ElseIf GUICtrlRead($c_Material) = "" Then
	  MsgBox(48, "", "Veuillez saisir un outillage!", -1, $hGUI_2)

   ElseIf GUICtrlRead($c_Tool) = "" Then
	  MsgBox(48, "", "Veuillez saisir le numéro de l'outillage retiré!", -1, $hGUI_2)

   ElseIf GUICtrlRead($c_ToolInPlace) = "" Then
	  MsgBox(48, "", "Veuillez saisir le numéro de l'outillage mis en place!", -1, $hGUI_2)

   ElseIf GUICtrlRead($iComment) = "" Then
	  MsgBox(48, "", "Veuillez saisir un commentaire!")

   ElseIf GUICtrlGetState($iValvePlace) = 80 And GUICtrlRead($iValvePlace) = "" Then
	  MsgBox(64, "", "Veuillez saisir l'emplacement de la " & GUICtrlRead($c_Tool) & " changée!", -1, $hGUI_2)

   ElseIf GUICtrlGetState($iValveOut) = 80 And GUICtrlRead($iValveOut) = "" Then
	  MsgBox(64, "", "Veuillez saisir le numéro de la " & GUICtrlRead($c_Tool) & " retirée!", -1, $hGUI_2)

   ElseIf GUICtrlGetState($iValveIn) = 80 And GUICtrlRead($iValveIn) = "" Then
	  MsgBox(64, "", "Veuillez saisir le numéro de la " & GUICtrlRead($c_Tool) & " mise en place!", -1, $hGUI_2)

   ElseIf GUICtrlRead($iDemandeur) = "" Then
	  MsgBox(48, "", "Veuillez saisir votre nom!", -1, $hGUI_2)

   ;ElseIf $CounthListView <> 0 And _GUICtrlListView_GetItemText($hListView, $IndexItemhListView) = "" Then
	  ;MsgBox(48, "", "Veuillez saisir la nature du défaut!", -1, $hGUI)

   Else
	  ;Récupération des Items sélectionner dans la ListView2

	  ;$Count = ControlListView($hGUI, "", $hListView, "GetItemCount")

	  ;For $i = 0 To $Count - 1
		 ;If ControlListView($hGUI, "", $hListView, "IsSelected", $i) Then
			;$SelectedValuehListView &= ControlListView($hGUI, "", $hListView, "GetText", $i) & ";"
		 ;EndIf
	  ;Next

	  ;$SelectedValuehListView = StringTrimRight($SelectedValuehListView, 1) ; Suppression du ";" en fin de String
	  ;$SelectedValuehListView = StringReplace($SelectedValuehListView, ";", " - ")

	  ;_SaveIntoSQLite()
	  ;MsgBox(64, "Sauvergarde", "Sauvergarde reussie", -1, $hGUI)
	  _CheckSQL()
	  _CloseMaterialChange()
   EndIf
EndFunc

; #Func _HTML ==========================================================================================================
;Fill & display a HTML sheet for printing
;=======================================================================================================================
Func _HTML($Material, $Tool, $ToolInPlace, $Comment)
   _DisplayName()
   $oIE = _IECreate("about:blank", 0,0,0)
   Local $hwndIE = _IEPropertyGet ($oIE, "hwnd")
   Local $oBody = _IETagNameGetCollection($oIE, "body", 0)
   $sHTML = @CRLF & "<!DOCTYPE HTML PUBLIC " & Chr(34) & "-//W3C//DTD HTML 4.01 Transitional//EN" & Chr(34) & @CRLF & @TAB & @TAB & Chr(34) & "http://www.w3.org/TR/html4/loose.dtd" & Chr(34) & ">" & @CRLF
   $sHTML &= "<html>" & @CRLF
   $sHTML &= "<head>" & @CRLF
   $sHTML &= "  <meta http-equiv=" & Chr(34) & "Content-Type" & Chr(34) & " content=" & Chr(34) & "text/html" & ";" & " charset=ISO-8859-1" & Chr(34) & ">" & @CRLF
   $sHTML &= "    <title>" & "Feuille de réparation" & "</title>" & @CRLF
   $sHTML &= "<style type=" & Chr(34) & "text/css" & Chr(34) & ">" & @CRLF
   $sHTML &= "td { white-space:nowrap; background-color:transparent; color:black; font-size:10pt; font-weight:normal; font-family:monospace,arial,sans-serif; border-width:thin; border-style:solid none none none; }" & @CRLF
   $sHTML &= "body { background-color:transparent; color:Black; font-size:8pt; font-weight:normal; font-family:monospace,arial,sans-serif;height: 100%; }" & @CRLF
   $sHTML &= "table#t01 tr:nth-child(even) {background-color: #eee;}" & @CRLF
   $sHTML &= "table#t01 tr:nth-child(odd) {background-color: #fff;}" & @CRLF
   $sHTML &= "</style>" & @CRLF
   $sHTML &= @CRLF
   $sHTML &= "</head>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td colspan=0 align='center' style='width:100%;background-color:#3A5A82; color:white; font-size:18pt; '>" & $Material & "</font></td>" & @CRLF
   $sHTML &= "<tr><td align='left' style='width:100%;border-style:none none solid none;'></td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   $sHTML &= "<BR>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td align='left' style='width:100%;border-style:none none none none; font-size:12pt;'>" & "<b>"& "Ligne: "& "</b>" & GUICtrlRead($c_Line) & "</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td align='left' style='width:100%;border-style:none none none none; font-size:12pt;'>" & "<b>" & "Station: " & "</b>" & GUICtrlRead($c_Cell) & "</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td align='left' style='width:100%;border-style:none none none none; font-size:12pt;'>" & "<b>Matériel: " & "</b>" & GUICtrlRead($c_Material) & "</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td align='left' style='width:100%;border-style:none none none none; font-size:12pt;'>" & "<b>" & "Matériel enlevé: "& "</b>" & GUICtrlRead($c_Tool) & "</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td align='left' style='width:100%;border-style:none none none none; font-size:12pt;'>" & "<b>" & "Matériel en place: "& "</b>" & GUICtrlRead($c_ToolInPlace) & "</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF

   If GUICtrlGetState($iValvePlace) = 80 And GUICtrlGetState($iValveOut) = 80 And GUICtrlGetState($iValveIn) = 80  Then
	  $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
	  $sHTML &= "<tr><td headers='ValvePlace' align='left' style='width:100%;border-style:none none none none; font-size:12pt;'><b>" & "Emplacement " &  GUICtrlRead($c_Tool) & ": " & "</b>" & GUICtrlRead($iValvePlace) & "</td></tr>" & @CRLF
	  $sHTML &= "</tbody></table>" & @CRLF
	  $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
	  $sHTML &= "<tr><td headers='ValveOut' align='left' style='width:100%;border-style:none none none none; font-size:12pt;'><b>" & "N° " & GUICtrlRead($c_Tool) & " enlevée: " & "</b>" & GUICtrlRead($iValveOut) & "</td></tr>" & @CRLF
	  $sHTML &= "</tbody></table>" & @CRLF
	  $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
	  $sHTML &= "<tr><td headers='ValveIn' align='left' style='width:100%;border-style:none none none none; font-size:12pt;'><b>" & "N° " & GUICtrlRead($c_Tool) & " en place: " & "</b>" & GUICtrlRead($iValveIn) & "</td></tr>" & @CRLF
	  $sHTML &= "</tbody></table>" & @CRLF
   EndIf

   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td headers='Demandeur' align='left' style='width:100%;border-style:none none none none; font-size:12pt;'>" & "<b>" & "Demandeur: "& "</b>" & GUICtrlRead($iDemandeur) & "</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td headers='Commentaire' align='left' style='width:100%;border-style:none none none none; font-size:12pt;'>" & "<b>" & "Commentaire(s): "& "</b>" & GUICtrlRead($iComment) & "</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td headers='Date' align='left' style='width:100%;border-style:none none none none; font-size:12pt;'>" & "<b>" & "Date: "& "</b>" &_Now() & "</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   $sHTML &= "<BR>" & @CRLF
   $sHTML &= "<BR>" & @CRLF
   $sHTML &= "<BR>" & @CRLF
   $sHTML &= "<table border='0' cellpadding='0' cellspacing='0' rules='none' style='width:100%'><tbody valign='top'>" & @CRLF
   $sHTML &= "<tr><td align='left' style='width:100%;border-style:none none solid none;'></td></tr>" & @CRLF
   $sHTML &= "<tr><td align='left' style='width:100%;border-style:none none none none; font-size:10pt;'>Generated by " & $sDisplayName & " Powered By <b>ME</b> le " & _Now() & " sur " & @ComputerName & " " & @LogonDomain & "\" & StringUpper(@UserName) &  ".</td></tr>" & @CRLF
   $sHTML &= "</tbody></table>" & @CRLF
   ;FileWrite(@ScriptDir & "\HTML\" & $Material & ".html", $sHTML)
   _IEDocWriteHTML($oIE, $sHTML)
   WinSetState($hwndIE, "", @SW_MAXIMIZE)
EndFunc

;Func _DisplayName()
   ;$oADSystemInfo  = ObjCreate("ADSystemInfo")
   ;If $oADSystemInfo <> 0 Then $oADsUser = ObjGet("LDAP://" & $oADSystemInfo.UserName)

   ;If IsObj($oADsUser) Then
	  ;$sDisplayName = $oADsUser.DisplayName
  ;EndIf
;EndFunc

; #Func _ToolInPlace# ==================================================================================================
;Tool in place on station in exchange of the older
;=======================================================================================================================
Func _ToolInPlace()
   GUICtrlSetData($c_ToolInPlace, "")
   $sSerial2 = IniRead($ConfigMaterial, $sLineCompose & "_" & $aSplit[1], GUICtrlRead($c_Material), "")
   $aSerial2 = StringSplit($sSerial2, ";")

   For $l= 1 To $aSerial2[0]
	  If $aSerial2[1] = "" Then
		 GUICtrlSetData($c_ToolInPlace, GUICtrlRead($c_Tool))
	  Else
		 GUICtrlSetData($c_ToolInPlace, $aSerial2[$l])
	  EndIf
   Next
EndFunc

; #Func _CloseMaterialChange# ==========================================================================================
;
;=======================================================================================================================
Func _CloseMaterialChange()
   GUIDelete($hGUI_2)
   GUISetState(@SW_ENABLE, $hGUI)
EndFunc

; #Func _FillCell# =====================================================================================================
;Fill ComboBox according ini file and ComboBox selection
; ======================================================================================================================
Func _FillCell()
   GUICtrlSetData($c_Cell, "")
   GUICtrlSetData($c_Material, "")
   GUICtrlSetData($c_Tool, "")
   GUICtrlSetData($iDefault, "")
   ;GUICtrlSetData($Label5, "")
   ;_GUICtrlListView_DeleteAllItems($hListView)
   $sLineCompose = IniRead($ConfigFile, "LINE", GUICtrlRead($c_Line), "No")
   If $sLineCompose = "No" Then Return MsgBox(16, "Error", "Ini file corrupted, end of programm")
   $aCell = IniReadSection($ConfigCell, $sLineCompose)
   If Not @error Then
	  For $j=1 To $aCell[0][0]
		 GUICtrlSetData($c_Cell, $aCell[$j][0] & " " & $aCell[$j][1])
	  Next
   EndIf
EndFunc

; #Func _FillRemoveTool# ===============================================================================================
;Fill ComboBox according ini file and ComboBox selection
; ======================================================================================================================
Func _FillRemoveTool()
   ;_GUICtrlListView_DeleteAllItems($hListView)
   GUICtrlSetData($c_Tool, "")
   GUICtrlSetData($c_ToolInPlace, "")
   GUICtrlSetData($iValvePlace, "")
   GUICtrlSetData($iValveOut, "")
   GUICtrlSetData($iValveIn, "")
   GUICtrlSetData($iComment, "")
   $sSerial2 = IniRead($ConfigMaterial, $sLineCompose & "_" & $aSplit[1], GUICtrlRead($c_Material), "")
   $aSerial2 = StringSplit($sSerial2, ";")

   For $l= 1 To $aSerial2[0]
	  If $aSerial2[1] = "" Then
		 GUICtrlSetData($c_Tool, GUICtrlRead($c_Material))
	  Else
		 GUICtrlSetData($c_Tool, $aSerial2[$l])
	  EndIf
   Next

   If StringInStr(GUICtrlRead($c_Material), "Vanne") Then
	  GUICtrlSetState($Label6, $GUI_SHOW)
	  GUICtrlSetState($Label7, $GUI_SHOW)
	  GUICtrlSetState($Label8, $GUI_SHOW)
	  GUICtrlSetState($Label9, $GUI_SHOW)
	  GUICtrlSetState($iValvePlace, $GUI_SHOW)
	  GUICtrlSetState($iValveOut, $GUI_SHOW)
	  GUICtrlSetState($iValveIn, $GUI_SHOW)
   Else
	  GUICtrlSetState($Label6, $GUI_HIDE)
	  GUICtrlSetState($Label7, $GUI_HIDE)
	  GUICtrlSetState($Label8, $GUI_HIDE)
	  GUICtrlSetState($Label9, $GUI_HIDE)
	  GUICtrlSetState($iValvePlace, $GUI_HIDE)
	  GUICtrlSetState($iValveOut, $GUI_HIDE)
	  GUICtrlSetState($iValveIn, $GUI_HIDE)
   EndIf
EndFunc

; #Func _FillDefault# ==================================================================================================
;Fill InputBox according ini file and ComboBox selection
; ======================================================================================================================
Func _FillDefault()
   ;..............
EndFunc

; #Func _LikeSearch# ===================================================================================================
;Recherche dans le base SQL par mot clé
; ======================================================================================================================
Func _LikeSearch()
   ;_GUICtrlListView_DeleteAllItems($hListView)
   Local $EquipmentSearch = StringReplace(GUICtrlRead($c_Search), "'", "''")
   Local $aResultSearch, $aRowSearch, $iRowsSearch, $iColumnsSearch

   If GUICtrlRead($c_Search) = "VANNE SITEC NO" Or GUICtrlRead($c_Search) = "VANNE SITEC NC" Then
	  $iRvalSearch = _SQLite_GetTable2d(-1, "SELECT * FROM SITEC_Valve WHERE Equipment = '" & $EquipmentSearch & "';", $aResultSearch, $iRowsSearch, $iColumnsSearch)
	  _SQLite_QuerySingleRow(-1, "SELECT Count(*) FROM SITEC_Valve WHERE Equipment = '" & $EquipmentSearch & "';", $aRowSearch)
   Else
	  $iRvalSearch = _SQLite_GetTable2d(-1, "SELECT * FROM Enregistrement WHERE Equipment = '" & $EquipmentSearch & "';", $aResultSearch, $iRowsSearch, $iColumnsSearch)
   	  _SQLite_QuerySingleRow(-1, "SELECT Count(*) FROM Enregistrement WHERE Equipment = '" & $EquipmentSearch & "';", $aRowSearch)
   EndIf

   If $iRvalSearch = $SQLITE_OK Then
	  _ArrayDelete($aResultSearch, 0)
	  _GUICtrlListView_DeleteAllItems($hListView)
	  _GUICtrlListView_AddArray($hListView, $aResultSearch)
	  My_GUICtrlListView_AutoSizeColumns($hListView)
	  $TxtNumberRecord=$aRowSearch[0] & " matériel" & ($aRowSearch[0] > 1 ? "s" : "") & " trouvé" & ($aRowSearch[0] > 1 ? "s" : "") & " pour la recherche " &  "'" & GUICtrlRead($c_Search) & "'"
	  GUICtrlSetData($Label5, $TxtNumberRecord)
   EndIf
EndFunc

; #Func _Exit# =========================================================================================================
;Exit
; ======================================================================================================================
Func _Exit()
   Exit
EndFunc

; #Func WM_NOTIFY# =====================================================================================================
;
; ======================================================================================================================
Func WM_NOTIFY($hWnd, $iMsg, $iwParam, $ilParam)
   #forceref $hWnd, $iMsg, $iwParam
   Local $hWndFrom, $iIDFrom, $iCode, $tNMHDR, $tInfo, $Index, $tNMITEMACTIVATE, $Index2
   Local $hQuery
   Local $hWndListView = $hListView
   If Not IsHWnd($hWndListView) Then $hWndListView = GUICtrlGetHandle($hListView)
   $tNMHDR = DllStructCreate($tagNMHDR, $ilParam)
   $tNMITEMACTIVATE = DllStructCreate($tagNMITEMACTIVATE, $ilParam)
   $hWndFrom = HWnd(DllStructGetData($tNMHDR, "hWndFrom"))
   $iIDFrom = DllStructGetData($tNMHDR, "IDFrom")
   $iCode = DllStructGetData($tNMHDR, "Code")
   $Index = DllStructGetData($tNMHDR, "Index")
   $Index2 = DllStructGetData($tNMITEMACTIVATE, 'Index')
   Switch $hWndFrom
	  Case $hWndListView
		 Switch $iCode
			Case $NM_RCLICK
			   ;$IndexItemListView = _GUICtrlListView_GetNextItem($hListView)
			   ;If _GUICtrlListView_GetNextItem($hListView) = -1 And _GUICtrlListView_GetItemText($hListView, $IndexItemListView) = "" Then Return
			   ;==[On supprime si Administrateur]==========
			   ;For $i = 0 To UBound($Admin) - 1
				  ;If StringUpper(@UserName) = $Admin[$i] And _GUICtrlListView_GetNextItem($hListView) <> -1 Then
					 ;Local $Question = MsgBox(20, $ApplicationName & " - Suppression article", "Voulez-vous vraiment supprimer l'entrée " &  _GUICtrlListView_GetItemText($hListView, $IndexItemListView, 3) & "?", -1, $hGUI)
						;If $Question = 6 Then
						   ;$IndexItemListView = _GUICtrlListView_GetNextItem($hListView)
						   ;$aItem = _GUICtrlListView_GetItemText($hListView, $IndexItemListView)
						   ;_SQlite_Query (-1, "SELECT * FROM " & $Table & " WHERE ID = " & $aItem & ";", $hQuery)
						   ;Local $req =_SQLite_Exec (-1, "DELETE FROM " & $Table & " WHERE ID = " & $aItem & ";")
						   ;If $req <> $SQLITE_OK Then Exit MsgBox(0,"Une erreur est survenue", "Effacement impossible.", -1, $hGUI)
						   ;==[Enregistrement dans fichier Delete.log pour suivi mouvement des stocks]====
						   ;_FileWriteLog(@ScriptDir & "\log\Deleted.log", StringUpper(@UserName) & "; " & @ComputerName & "; " &  _GUICtrlListView_GetItemText($hListView, $IndexItemListView, 3))
						   ;_LoadSQLiteData()
						;Else
						   ;Return
						;EndIf
				  ;EndIf
			   ;Next
			Case $NM_DBLCLK
			   $IndexItemListView = _GUICtrlListView_GetNextItem($hListView)
			   If _GUICtrlListView_GetNextItem($hListView) = -1 And _GUICtrlListView_GetItemText($hListView, $IndexItemListView) = "" Then Return
			   ;For $i = 0 To UBound($Admin) - 1
				  ;If StringUpper(@UserName) = $Admin[$i] And _GUICtrlListView_GetNextItem($hListView) <> -1 Then
					 Local $_Question = MsgBox(36, "Modifications article", "Voulez-vous modifier l'entrée " &  _GUICtrlListView_GetItemText($hListView, $IndexItemListView, 0) & "?", -1, $hGUI)
					 ;If $_Question = 6 Then
						;_PopUpModify()
						;GUICtrlSetState($hListView, $GUI_DISABLE)
					 ;Else
						;Return
					 ;EndIf
				  ;EndIf
			   ;Next
			Case $NM_CUSTOMDRAW
			   If Not _GUICtrlListView_GetViewDetails($hWndFrom) Then Return $GUI_RUNDEFMSG
			   Local $tCustDraw = DllStructCreate('hwnd hwndFrom;int idFrom;int code;' & _
				  'dword DrawStage;hwnd hdc;long rect[4];dword ItemSpec;int ItemState;dword Itemlparam;' & _
				  'dword clrText;dword clrTextBk;int SubItem;' & _
				  'dword ItemType;dword clrFace;int IconEffect;int IconPhase;int PartID;int StateID;long rectText[4];int Align', _ ;winxp or later
				  $ilParam), $iDrawStage, $iItem, $iSubitem, $hDC, $iColor1, $iColor2, $iColor3
				  $iDrawStage = DllStructGetData($tCustDraw, 'DrawStage')
				  If $iDrawStage = $CDDS_PREPAINT Then Return $CDRF_NOTIFYITEMDRAW ;request custom drawing of items
				  If $iDrawStage = $CDDS_ITEMPREPAINT Then Return $CDRF_NOTIFYSUBITEMDRAW ;request drawing each cell separately
				  If Not BitAND($iDrawStage, $CDDS_SUBITEM) Then Return $CDRF_DODEFAULT
				  $iItem = DllStructGetData($tCustDraw, 'ItemSpec')
				  $iSubitem = DllStructGetData($tCustDraw, 'SubItem')
		 Switch $iItem
			Case 0 To _GUICtrlListView_GetItemCount($hListView)
			   $iColor1 = RGB2BGR(0XF0EEE9)
			   $iColor2 = RGB2BGR(0xFFFFFF)
			   $hDC = DllStructGetData($tCustDraw, 'hdc')
			   If Mod($iItem, 2) Then
				  If Mod($iSubitem, 2) Then
					 DllStructSetData($tCustDraw, 'clrTextBk', $iColor1)
				  Else
					 DllStructSetData($tCustDraw, 'clrTextBk', $iColor1)
				  EndIf
					 ;DLLCall("gdi32.dll","hwnd","SelectObject", "hwnd", $hDC, "hwnd", $aFont1[0]) ;    <- Police Gras & noir
			   Else
				  If Mod($iSubitem, 2) Then
					 DllStructSetData($tCustDraw, 'clrTextBk', $iColor2)
				  Else
					 DllStructSetData($tCustDraw, 'clrTextBk', $iColor2)
				  EndIf
					 ;DLLCall("gdi32.dll","hwnd","SelectObject", "hwnd", $hDC, "hwnd", $aFont2[0])
			   EndIf
		 EndSwitch
		 Return $CDRF_NEWFONT
	  EndSwitch
   EndSwitch
   Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_NOTIFY

; #Func RGB2BGR# =======================================================================================================
;
; ======================================================================================================================
Func RGB2BGR($iColor)
   Return BitAND(BitShift(String(Binary($iColor)), 8), 0xFFFFFF)
EndFunc

; #Func WM_TIMER# ======================================================================================================
; Main Graphical User Interface
; ======================================================================================================================
Func WM_TIMER($hWnd, $iMsg, $iwParam, $ilParam)
   #forceref $hWnd, $iMsg, $ilParam
   Switch _Timer_GetTimerID($iwParam)
	  Case $iTimer
		 _UpdateStatusBarClock()
   EndSwitch
   Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_TIMER

; #Func _UpdateStatusBarClock# =========================================================================================
;
; ======================================================================================================================
Func _UpdateStatusBarClock()
   _GUICtrlStatusBar_SetText($hStatus, @TAB & StringFormat(_NowDate() & " " & "%02d:%02d:%02d", @HOUR, @MIN, @SEC), 0)
EndFunc

; #Func WM_SIZE# =======================================================================================================
;
; ======================================================================================================================
Func WM_SIZE($hWnd, $iMsg, $iwParam, $ilParam)
   #forceref $hWnd, $iMsg, $iwParam, $ilParam
   _GUICtrlStatusBar_Resize($hStatus)
   Return $GUI_RUNDEFMSG
EndFunc   ;==>WM_SIZE

; #Func _ScreenAdaptation# =============================================================================================
; Screen adaptation: GUI fills all monitor screen size
; ======================================================================================================================
Func _ScreenAdaptation()
   $WorkAera = _GetWorkArea()
   Local $aGuiPos = WinGetPos($hGUI)
   If $aGuiPos[0] <> $WorkAera[0] Or $aGuiPos[1] <> $WorkAera[1] Or $aGuiPos[2] <> $WorkAera[4] Or $aGuiPos[3] <> $WorkAera[5] Then
	  ;WinMove ( "title", "text", x, y [, width [, height [, speed]]] )
	  WinMove($hGUI, "", $WorkAera[0], $WorkAera[1], $WorkAera[4], $WorkAera[5])
	  ;GUICtrlSetPos(controlID, left, top, width, height)
	  GUICtrlSetPos($hTitle, 1, 1, $WorkAera[4]-2, 30)		;Titre
	  GUICtrlSetPos($Label1, 1, 60, 80, 20)					;Ligne
	  GUICtrlSetPos($c_Line, 1, 80, 300, 20)
	  GUICtrlSetPos($Label2, 1, 105, 80, 20)				;Station
	  GUICtrlSetPos($c_Cell, 1, 125, 300, 20)
	  GUICtrlSetPos($c_Material, 1, 145, 300, 20)
	  GUICtrlSetPos($bExtractionExcel, 1, 270, 300, 25)
	  GUICtrlSetPos($bStat, 1, 300, 300, 25)
	  GUICtrlSetPos($hListView, 320, 80, $WorkAera[4]-321, 245)
	  GUICtrlSetPos($Label4, 1, 190, 250, 20)				;Recherche par mot-clef
	  GUICtrlSetPos($c_Search, 1, 210, 300, 25) ;$iSearch
	  GUICtrlSetPos($bSearch, 1, 240, 300, 25)
	  GUICtrlSetPos($Label5, 320, 45, $WorkAera[4]-321, 30)	;Label résultat nombre matériel trouvé selon recherche ($WorkAera[4]-321)
   EndIf
   ; Adaptation des tailles de police des controls
   _SetFontSizeForControl($hGUI, $hTitle, $sFont, 400, 0)
   _SetFontSizeForControl($hGUI, $Label1, $sFont, 400, 0)
   _SetFontSizeForControl($hGUI, $Label2, $sFont, 400, 0)
   _SetFontSizeForControl($hGUI, $bStat, $sFont, 400, 0)
   _SetFontSizeForControl($hGUI, $Label4, $sFont, 400, 0)
   _SetFontSizeForControl($hGUI, $Label5, $sFont, 400, 0)
   _SetFontSizeForControl($hGUI, $bExtractionExcel, $sFont, 400, 0)
EndFunc

; #Func _GetWorkArea# ==================================================================================================
; Get size of monitor screen
; ======================================================================================================================
Func _GetWorkArea()
   Local $StartRect = DllStructCreate("int[4]")
   Local $PStartRect = DllStructGetPtr($StartRect)
   DllCall("user32.dll", "int", "SystemParametersInfo", "int", 48, "int", 0, "ptr", $PStartRect, "int", 0)
   $Area[0] = DllStructGetData($StartRect, 1, 1)
   $Area[1] = DllStructGetData($StartRect, 1, 2)
   $Area[2] = DllStructGetData($StartRect, 1, 3)
   $Area[3] = DllStructGetData($StartRect, 1, 4)
   $Area[4] = $Area[2] - $Area[0]
   $Area[5] = $Area[3] - $Area[1]
   Return $Area
EndFunc   ;==>_GetWorkArea

; #Func _SetFontSizeForControl# ========================================================================================
;
; ======================================================================================================================
Func _SetFontSizeForControl($Gui, $Control, $Font = Default, $Weight = Default, $Attrib = 0)
   ; On récupère la taille du control
   $ControlSize = ControlGetPos($Gui, "", $Control)
   If @error Then Return False
   ; On récupère le texte du control
   $Text = GUICtrlRead($Control)
   ; On essaye toutes les tailles de police et on voit laquelle correspond le mieux
   For $i = 1 To 100 Step 1
	  $Size = _StringSize($Text, $i, $Weight, $Attrib, $Font)
	  If Not IsArray($Size) Then Return False
	  ; On vérifie si la police est trop grande
	  If $Size[2] > $ControlSize[2] Or $Size[1] > $ControlSize[3] Then ExitLoop
   Next
   ; On définit la bonne taille
   Return GUICtrlSetFont($Control, $i-1, $Weight, $Attrib, $Font)
EndFunc

Func My_GUICtrlListView_AutoSizeColumns($hListview, $iMini = 80)
    If Not IsHWnd($hListview) Then $hListview = GUICtrlGetHandle($hListview)
    Local $hHeader = _GUICtrlListView_GetHeader($hListview), $iHeader_Width, $iData_Width
    _GUICtrlListView_BeginUpdate($hListview)
    For $iIndex = 0 To _GUICtrlListView_GetColumnCount($hListview) - 1
        If _GUICtrlListView_GetColumnWidth($hListview, $iIndex) = 0 Then ContinueLoop
        _GUICtrlListView_SetColumnWidth($hListview, $iIndex, $LVSCW_AUTOSIZE_USEHEADER)
        $iHeader_Width = _GUICtrlListView_GetColumnWidth($hListview, $iIndex)
        If @OSVersion = "WIN_XP" And $iIndex < _GUICtrlListView_GetColumnCount($hListview) - 1 Then
            If _GUICtrlHeader_GetItemFlags($hHeader, $iIndex) / 2 > 1 Then $iHeader_Width += 30
        EndIf
        _GUICtrlListView_SetColumnWidth($hListview, $iIndex, $LVSCW_AUTOSIZE)
        $iData_Width = _GUICtrlListView_GetColumnWidth($hListview, $iIndex)
        If $iHeader_Width > $iData_Width Then
            _GUICtrlListView_SetColumnWidth($hListview, $iIndex, $iHeader_Width)
        EndIf
        If _GUICtrlListView_GetColumnWidth($hListview, $iIndex) < $iMini Then
            _GUICtrlListView_SetColumnWidth($hListview, $iIndex, $iMini)
        EndIf
    Next
    _GUICtrlListView_EndUpdate($hListview)
EndFunc   ;==>My_GUICtrlListView_AutoSizeColumns
